diff -ruN qmail-1.03-orig/qmail-pop3d.c qmail-1.03-ldap-20060201-orig/qmail-pop3d.c
--- qmail-1.03-orig/qmail-pop3d.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-pop3d.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,10 +1,13 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <stdio.h>
+#include <unistd.h>
 #include "commands.h"
 #include "sig.h"
 #include "getln.h"
 #include "stralloc.h"
 #include "substdio.h"
+#include "subfd.h"
 #include "alloc.h"
 #include "open.h"
 #include "prioq.h"
@@ -17,9 +20,48 @@
 #include "timeoutread.h"
 #include "timeoutwrite.h"
 
-void die() { _exit(0); }
+#include "env.h"
+#include "maildir++.h"
+#include "qmail-ldap.h"
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+int qfd;
+ 
+/* level 0 = no logging
+         1 = fatal errors
+         2 = login/logout accounting
+         3 = session errors
+	 4 = verbose
+ */
+int loglevel = 0;
+stralloc logs_pidhostinfo = {0};
+unsigned long log_bytes = 0;
+
+void logit(int l, const char *s)
+{
+	if(l <= loglevel)
+		substdio_puts(subfderr,s);
+}
+void logitf(int l, const char *s)
+{
+	if(l > loglevel) return;
+	substdio_puts(subfderr,s);
+	substdio_putsflush(subfderr,"\n");
+}
+
+void log_quit(void)
+{
+  char strnum[FMT_ULONG];
+
+  logit(2, "acct:");
+  logit(2, logs_pidhostinfo.s);
+  logit(2, "logout ");
+  strnum[fmt_ulong(strnum,log_bytes)] = 0;
+  logit(2, strnum); logitf(2, " bytes transferred");
+}
+
+void die(void) { log_quit(); _exit(0); }
+
+int saferead(int fd, void *buf, int len)
 {
   int r;
   r = timeoutread(1200,fd,buf,len);
@@ -27,7 +69,7 @@
   return r;
 }
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+int safewrite(int fd, void *buf, int len)
 {
   int r;
   r = timeoutwrite(1200,fd,buf,len);
@@ -41,52 +83,94 @@
 char ssinbuf[128];
 substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
 
-void put(buf,len) char *buf; int len;
+void put(const char *buf, int len)
 {
   substdio_put(&ssout,buf,len);
 }
-void puts(s) char *s;
+void putstr(const char *s)
 {
   substdio_puts(&ssout,s);
 }
-void flush()
+void flush(void)
 {
   substdio_flush(&ssout);
 }
-void err(s) char *s;
+void err(const char *s)
 {
-  puts("-ERR ");
-  puts(s);
-  puts("\r\n");
+  putstr("-ERR ");
+  putstr(s);
+  putstr("\r\n");
   flush();
 }
 
-void die_nomem() { err("out of memory"); die(); }
-void die_nomaildir() { err("this user has no $HOME/Maildir"); die(); }
-void die_scan() { err("unable to scan $HOME/Maildir"); die(); }
-
-void err_syntax() { err("syntax error"); }
-void err_unimpl() { err("unimplemented"); }
-void err_deleted() { err("already deleted"); }
-void err_nozero() { err("messages are counted from 1"); }
-void err_toobig() { err("not that many messages"); }
-void err_nosuch() { err("unable to open that message"); }
-void err_nounlink() { err("unable to unlink all deleted messages"); }
+void die_nomem(void) { err("out of memory");
+	logitf(1, "panic: out of memory"); die(); }
+void die_nomaildir(void) { err("this user has no $HOME/Maildir");
+	logitf(1, "panic: this user has no $HOME/Maildir"); die(); }
+void die_scan(void) { err("unable to scan $HOME/Maildir");
+	logitf(1, "unable to scan $HOME/Maildir"); die(); }
+
+void err_syntax(void) { err("syntax error"); logitf(3, "error: syntax error"); }
+void err_unimpl(void) { err("unimplemented"); logitf(3, "error: unimplemented"); }
+void err_deleted(void) { err("already deleted"); logitf(3, "already deleted"); }
+void err_nozero(void) { err("messages are counted from 1"); logitf(3, "messages are counted from 1"); }
+void err_toobig(void) { err("not that many messages"); logitf(3, "not that many messages"); }
+void err_nosuch(void) { err("unable to open that message"); logitf(3, "unable to open that message"); }
+void err_nounlink(void) { err("unable to unlink all deleted messages"); logitf(3, "unable to unlink all deleted messages"); }
 
-void okay() { puts("+OK \r\n"); flush(); }
+void okay(void) { putstr("+OK \r\n"); flush(); }
 
-void printfn(fn) char *fn;
+void printfn(const char *fn)
 {
   fn += 4;
   put(fn,str_chr(fn,':'));
 }
 
+void log_init(void)
+{
+  char strnum[FMT_ULONG];
+  const char *remotehost;
+  const char *remoteip;
+  const char *remoteinfo;
+  const char *user;
+  char *l;
+  unsigned long v;
+  
+  l = env_get("POP3_LOGLEVEL");
+  if (l) { scan_ulong(l,&v); loglevel = v; };
+
+  remoteip = env_get("TCPREMOTEIP");
+  if (!remoteip) remoteip = "unknown";
+  remotehost = env_get("TCPREMOTEHOST");
+  if (!remotehost) remotehost = "unknown";
+  remoteinfo = env_get("TCPREMOTEINFO");
+  if (!remoteinfo) remoteinfo = "";
+  user = env_get("USER");
+  if (!user) user = "unknown";
+
+  if (!stralloc_copys(&logs_pidhostinfo, " pid ")) die_nomem();
+  strnum[fmt_ulong(strnum,getpid())] = 0;
+  if (!stralloc_cats(&logs_pidhostinfo, strnum)) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, ": ")) die_nomem();
+
+  if (!stralloc_cats(&logs_pidhostinfo, remotehost)) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, ":")) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, remoteip)) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, ":")) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, remoteinfo)) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, " ")) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, user)) die_nomem();
+  if (!stralloc_cats(&logs_pidhostinfo, " ")) die_nomem();
+  if (!stralloc_0(&logs_pidhostinfo)) die_nomem();
+
+  logit(2, "acct:"); logit(2, logs_pidhostinfo.s); logitf(2, "login");
+}
+
+
 char strnum[FMT_ULONG];
 stralloc line = {0};
 
-void blast(ssfrom,limit)
-substdio *ssfrom;
-unsigned long limit;
+void blast(substdio *ssfrom, unsigned long limit)
 {
   int match;
   int inheaders = 1;
@@ -103,6 +187,7 @@
         put(".",1);
     put(line.s,line.len);
     put("\r\n",2);
+    log_bytes += line.len + 2;
     if (!match) break;
   }
   put("\r\n.\r\n",5);
@@ -117,15 +202,15 @@
   unsigned long size;
   char *fn;
 } *m;
-int numm;
+unsigned int numm;
 
-int last = 0;
+unsigned int last = 0;
 
-void getlist()
+void getlist(void)
 {
   struct prioq_elt pe;
   struct stat st;
-  int i;
+  unsigned int i;
  
   maildir_clean(&line);
   if (maildir_scan(&pq,&filenames,1,1) == -1) die_scan();
@@ -146,42 +231,64 @@
   }
 }
 
-void pop3_stat()
+void pop3_stat(char *arg)
 {
-  int i;
+  unsigned int i;
   unsigned long total;
+  unsigned int count;
  
+  logitf(4, "comm: stat");
   total = 0;
-  for (i = 0;i < numm;++i) if (!m[i].flagdeleted) total += m[i].size;
-  puts("+OK ");
-  put(strnum,fmt_uint(strnum,numm));
-  puts(" ");
+  count = 0;
+  for (i = 0;i < numm;++i) if (!m[i].flagdeleted) {
+    total += m[i].size;
+    count += 1;
+  }
+  putstr("+OK ");
+  put(strnum,fmt_uint(strnum,count));
+  putstr(" ");
   put(strnum,fmt_ulong(strnum,total));
-  puts("\r\n");
+  putstr("\r\n");
   flush();
 }
 
-void pop3_rset()
+void pop3_rset(char *arg)
 {
-  int i;
+  unsigned int i;
+
+  logitf(4, "comm: rset");
   for (i = 0;i < numm;++i) m[i].flagdeleted = 0;
   last = 0;
   okay();
 }
 
-void pop3_last()
+void pop3_last(char *arg)
 {
-  puts("+OK ");
+  logitf(4, "comm: last");
+  putstr("+OK ");
   put(strnum,fmt_uint(strnum,last));
-  puts("\r\n");
+  putstr("\r\n");
   flush();
 }
 
-void pop3_quit()
+void pop3_quit(char *arg)
 {
-  int i;
+  unsigned int i;
+  quota_t q;
+  
+  logitf(4, "comm: quit");
+/* qmail-ldap stuff */
+/* this is just minimal support, because pop3 can not produce new mail */
+  quota_get(&q, env_get(ENV_QUOTA));
+  if (quota_calc(".",&qfd, &q) == -1) {
+    /* second chance */
+    sleep(3);
+    quota_calc(".",&qfd, &q);
+  }
   for (i = 0;i < numm;++i)
     if (m[i].flagdeleted) {
+      if ( qfd != -1 ) quota_rm(qfd, m[i].size, 1);
+/* end qmail-ldap stuff */
       if (unlink(m[i].fn) == -1) err_nounlink();
     }
     else
@@ -193,10 +300,11 @@
 	rename(m[i].fn,line.s); /* if it fails, bummer */
       }
   okay();
+  if ( qfd != -1 ) close(qfd);
   die();
 }
 
-int msgno(arg) char *arg;
+unsigned int msgno(char *arg)
 {
   unsigned long u;
   if (!scan_ulong(arg,&u)) { err_syntax(); return -1; }
@@ -207,34 +315,34 @@
   return u;
 }
 
-void pop3_dele(arg) char *arg;
+void pop3_dele(char *arg)
 {
-  int i;
+  unsigned int i;
+
+  logit(4, "comm: dele: "); logitf(4, arg);
   i = msgno(arg);
-  if (i == -1) return;
+  if (i == (unsigned int)-1) return;
   m[i].flagdeleted = 1;
   if (i + 1 > last) last = i + 1;
   okay();
 }
 
-void list(i,flaguidl)
-int i;
-int flaguidl;
+void list(unsigned int i, int flaguidl)
 {
   put(strnum,fmt_uint(strnum,i + 1));
-  puts(" ");
+  putstr(" ");
   if (flaguidl) printfn(m[i].fn);
   else put(strnum,fmt_ulong(strnum,m[i].size));
-  puts("\r\n");
+  putstr("\r\n");
 }
 
-void dolisting(arg,flaguidl) char *arg; int flaguidl;
+void dolisting(char *arg, int flaguidl)
 {
   unsigned int i;
   if (*arg) {
     i = msgno(arg);
-    if (i == -1) return;
-    puts("+OK ");
+    if (i == (unsigned int)-1) return;
+    putstr("+OK ");
     list(i,flaguidl);
   }
   else {
@@ -242,24 +350,30 @@
     for (i = 0;i < numm;++i)
       if (!m[i].flagdeleted)
 	list(i,flaguidl);
-    puts(".\r\n");
+    putstr(".\r\n");
   }
   flush();
 }
 
-void pop3_uidl(arg) char *arg; { dolisting(arg,1); }
-void pop3_list(arg) char *arg; { dolisting(arg,0); }
+void pop3_uidl(char *arg) { 
+  logit(4, "comm: uidl: "); logitf(4, arg); dolisting(arg,1); }
+void pop3_list(char *arg) {
+  logit(4, "comm: list: "); logitf(4, arg); dolisting(arg,0); }
 
 substdio ssmsg; char ssmsgbuf[1024];
 
-void pop3_top(arg) char *arg;
+void pop3_top(char *arg)
 {
-  int i;
+  unsigned int i;
   unsigned long limit;
   int fd;
+#ifdef MAKE_NETSCAPE_WORK /* Based on a patch by sven@megabit.net */
+  char foo[FMT_ULONG];
+#endif
  
+  logit(4, "comm: retr/top: "); logitf(4, arg);
   i = msgno(arg);
-  if (i == -1) return;
+  if (i == (unsigned int)-1) return;
  
   arg += scan_ulong(arg,&limit);
   while (*arg == ' ') ++arg;
@@ -267,8 +381,19 @@
  
   fd = open_read(m[i].fn);
   if (fd == -1) { err_nosuch(); return; }
+
+#ifdef MAKE_NETSCAPE_WORK /* Based on a patch by sven@megabit.net */
+  putstr("+OK ");
+  foo[fmt_uint(foo,m[i].size)] = 0;
+  putstr(foo);
+
+  putstr(" octets \r\n");
+  flush();
+#else
   okay();
-  substdio_fdbuf(&ssmsg,read,fd,ssmsgbuf,sizeof(ssmsgbuf));
+#endif
+
+  substdio_fdbuf(&ssmsg,subread,fd,ssmsgbuf,sizeof(ssmsgbuf));
   blast(&ssmsg,limit);
   close(fd);
 }
@@ -287,19 +412,28 @@
 , { 0, err_unimpl, 0 }
 } ;
 
-void main(argc,argv)
-int argc;
-char **argv;
+int main(int argc, char **argv)
 {
+/* qmail-ldap stuff */
+  char *env;
+  
   sig_alarmcatch(die);
   sig_pipeignore();
- 
+  
+  /* if MAILDIR is defined us this as Maildir and not the argument */
+  if ( (env = env_get("MAILDIR") ) && *env ) argv[1] = env;
+
   if (!argv[1]) die_nomaildir();
-  if (chdir(argv[1]) == -1) die_nomaildir();
- 
+  if (chdir(argv[1]) == -1) {
+    die_nomaildir();
+  } 
+/* qmail-ldap stuff */
+
+  log_init();
   getlist();
 
   okay();
   commands(&ssin,pop3commands);
-  die();
+  log_quit();
+  return 0;
 }
diff -ruN qmail-1.03-orig/qmail-pop3d.rules qmail-1.03-ldap-20060201-orig/qmail-pop3d.rules
--- qmail-1.03-orig/qmail-pop3d.rules	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-pop3d.rules	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,9 @@
+#
+# POP3 Server rules.
+# Normaly you allow from everyware and the only useful env vars are
+# NOPBS, LOGLEVEL and POP3_LOGLEVEL.
+#
+# disable pop-befor-smtp on the loopback
+127.0.0.1:allow,NOPBS=""
+# default allow
+:allow
diff -ruN qmail-1.03-orig/qmail-pop3d.sh qmail-1.03-ldap-20060201-orig/qmail-pop3d.sh
--- qmail-1.03-orig/qmail-pop3d.sh	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-pop3d.sh	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,38 @@
+#!/bin/sh
+exec 2>&1
+#
+# POP3 service 
+#
+QMAIL="%QMAIL%"
+ME="`head -1 $QMAIL/control/me`"
+if [ -e $QMAIL/control/defaultdelivery ]; then
+        ALIASEMPTY=`head -1 $QMAIL/control/defaultdelivery 2> /dev/null`
+else
+        ALIASEMPTY=`head -1 $QMAIL/control/aliasempty 2> /dev/null`
+fi
+ALIASEMPTY=${ALIASEMPTY:="./Maildir/"}
+
+PATH="$QMAIL/bin:$PATH"
+
+# source the environemt in ./env
+eval `env - PATH=$PATH envdir ./env awk '\
+	BEGIN { for (i in ENVIRON) \
+		if (i != "PATH") { \
+			printf "export %s=\"%s\"\\n", i, ENVIRON[i] \
+		} \
+	}'`
+
+# enforce some sane defaults
+PBSTOOL=${PBSTOOL:="$QMAIL/bin/pbsadd"}
+
+if [ X${NOPBS+"true"} = X"true" ]; then
+	unset PBSTOOL
+fi
+
+exec \
+	tcpserver -v -HRl $ME -x$QMAIL/control/qmail-pop3d.cdb \
+	    ${CONCURRENCY:+"-c$CONCURRENCY"} ${BACKLOG:+"-b$BACKLOG"} 0 pop3 \
+	$QMAIL/bin/qmail-popup $ME \
+	$QMAIL/bin/auth_pop ${PBSTOOL:+"-d$PBSTOOL"} \
+	$QMAIL/bin/qmail-pop3d "$ALIASEMPTY"
+
diff -ruN qmail-1.03-orig/qmail-pop3d-ssl.sh qmail-1.03-ldap-20060201-orig/qmail-pop3d-ssl.sh
--- qmail-1.03-orig/qmail-pop3d-ssl.sh	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-pop3d-ssl.sh	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,40 @@
+#!/bin/sh
+exec 2>&1
+#
+# POP3 service 
+#
+QMAIL="%QMAIL%"
+ME="`head -1 $QMAIL/control/me`"
+if [ -e $QMAIL/control/defaultdelivery ]; then
+        ALIASEMPTY=`head -1 $QMAIL/control/defaultdelivery 2> /dev/null`
+else
+        ALIASEMPTY=`head -1 $QMAIL/control/aliasempty 2> /dev/null`
+fi
+ALIASEMPTY=${ALIASEMPTY:="./Maildir/"}
+
+PATH="$QMAIL/bin:$PATH"
+
+# source the environemt in ./env
+eval `env - PATH=$PATH envdir ./env awk '\
+	BEGIN { for (i in ENVIRON) \
+		if (i != "PATH") { \
+			printf "export %s=\"%s\"\\n", i, ENVIRON[i] \
+		} \
+	}'`
+
+# enforce some sane defaults
+TLSCERT=${TLSCERT:="$QMAIL/control/cert.pem"}
+PBSTOOL=${PBSTOOL:="$QMAIL/bin/pbsadd"}
+
+if [ X${NOPBS+"true"} = X"true" ]; then
+	unset PBSTOOL
+fi
+
+exec \
+	tcpserver -v -HRl $ME -x$QMAIL/control/qmail-pop3d.cdb \
+	    ${CONCURRENCY:+"-c$CONCURRENCY"} ${BACKLOG:+"-b$BACKLOG"} \
+	    -s ${TLSCERT:+"-n$TLSCERT"} 0 pop3s \
+	$QMAIL/bin/qmail-popup $ME \
+	$QMAIL/bin/auth_pop ${PBSTOOL:+"-d$PBSTOOL"}\
+	$QMAIL/bin/qmail-pop3d "$ALIASEMPTY"
+
diff -ruN qmail-1.03-orig/qmail-popup.c qmail-1.03-ldap-20060201-orig/qmail-popup.c
--- qmail-1.03-orig/qmail-popup.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-popup.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "commands.h"
 #include "fd.h"
 #include "sig.h"
@@ -14,9 +15,9 @@
 #include "timeoutread.h"
 #include "timeoutwrite.h"
 
-void die() { _exit(1); }
+void die(void) { _exit(1); }
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+int saferead(int fd, void *buf, int len)
 {
   int r;
   r = timeoutread(1200,fd,buf,len);
@@ -24,7 +25,7 @@
   return r;
 }
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+int safewrite(int fd, void *buf, int len)
 {
   int r;
   r = timeoutwrite(1200,fd,buf,len);
@@ -38,36 +39,62 @@
 char ssinbuf[128];
 substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
 
-void puts(s) char *s;
+void putstr(const char *s)
 {
   substdio_puts(&ssout,s);
 }
-void flush()
+void flush(void)
 {
   substdio_flush(&ssout);
 }
-void err(s) char *s;
+void err(const char *s)
 {
-  puts("-ERR ");
-  puts(s);
-  puts("\r\n");
+  putstr("-ERR ");
+  putstr(s);
+  putstr("\r\n");
   flush();
 }
 
-void die_usage() { err("usage: popup hostname subprogram"); die(); }
-void die_nomem() { err("out of memory"); die(); }
-void die_pipe() { err("unable to open pipe"); die(); }
-void die_write() { err("unable to write pipe"); die(); }
-void die_fork() { err("unable to fork"); die(); }
-void die_childcrashed() { err("aack, child crashed"); }
-void die_badauth() { err("authorization failed"); }
-
-void err_syntax() { err("syntax error"); }
-void err_wantuser() { err("USER first"); }
-void err_authoriz() { err("authorization first"); }
+void die_usage(void) { err("usage: popup hostname subprogram"); die(); }
+void die_nomem(void) { err("out of memory"); die(); }
+void die_pipe(void) { err("unable to open pipe"); die(); }
+void die_write(void) { err("unable to write pipe"); die(); }
+void die_fork(void) { err("unable to fork"); die(); }
+void die_childcrashed(void) { err("aack, child crashed"); }
+void die_badauth(void) { err("authorization failed"); }
+
+/* checkpassword error exit codes:
+ * 1 = error in server configuration
+ * 2 = unable to contact authorization server
+ * 25= user record incorrect
+ * 3 = authorization failed
+ * 4 = account disabled
+ * 5 = mailhost is unreachable
+ * 6 = mailbox is corrupted
+ * 61= mailbox creation failed
+ * 62= the users mailbox does not exist
+ * 7 = unable to start subprogram
+ * 8 = out of memory
+ */
+
+void die_1(void) { err("error in server configuration"); die(); }
+void die_2(void) { err("unable to contact authorization server"); die(); }
+void die_25(void) { err("user record incorrect"); die(); }
+void die_3(void) { err("authorization failed"); die(); }
+void die_4(void) { err("account disabled"); die(); }
+void die_5(void) { err("mailhost is unreachable"); die(); }
+void die_6(void) { err("mailbox is corrupted"); die(); }
+void die_61(void) { err("mailbox could not be created"); die(); }
+void die_62(void) { err("the users mailbox does not exist"); die(); }
+void die_7(void) { err("unable to start subprogram"); die(); }
+void die_unknown(void) { err("temporary error"); die(); }
+
+void err_syntax(void) { err("syntax error"); }
+void err_wantuser(void) { err("USER first"); }
+void err_authoriz(void) { err("authorization first"); }
 
-void okay() { puts("+OK \r\n"); flush(); }
-void pop3_quit() { okay(); die(); }
+void okay(void) { putstr("+OK \r\n"); flush(); }
+void pop3_quit(void) { okay(); die(); }
 
 
 char unique[FMT_ULONG + FMT_ULONG + 3];
@@ -79,16 +106,13 @@
 char upbuf[128];
 
 
-void doanddie(user,userlen,pass)
-char *user;
-unsigned int userlen; /* including 0 byte */
-char *pass;
+void doanddie(char *user, unsigned int userlen /* including 0 byte */,
+    char *pass)
 {
   int child;
   int wstat;
   int pi[2];
  
-  if (fd_copy(2,1) == -1) die_pipe();
   close(3);
   if (pipe(pi) == -1) die_pipe();
   if (pi[0] != 3) die_pipe();
@@ -102,7 +126,7 @@
       _exit(1);
   }
   close(pi[0]);
-  substdio_fdbuf(&ssup,write,pi[1],upbuf,sizeof upbuf);
+  substdio_fdbuf(&ssup,subwrite,pi[1],upbuf,sizeof upbuf);
   if (substdio_put(&ssup,user,userlen) == -1) die_write();
   if (substdio_put(&ssup,pass,str_len(pass) + 1) == -1) die_write();
   if (substdio_puts(&ssup,"<") == -1) die_write();
@@ -115,10 +139,25 @@
   byte_zero(upbuf,sizeof upbuf);
   if (wait_pid(&wstat,child) == -1) die();
   if (wait_crashed(wstat)) die_childcrashed();
-  if (wait_exitcode(wstat)) die_badauth();
+  switch (wait_exitcode(wstat)) {
+    case 0: die();
+    case 1: die_1();
+    case 2: die_2();
+    case 25: die_25();
+    case 3: die_3();
+    case 4: die_4();
+    case 5: die_5();
+    case 6: die_6();
+    case 61: die_61();
+    case 62: die_62();
+    case 7: die_7();
+    case 8: die_nomem();
+    default: die_unknown();
+  }
   die();
 }
-void pop3_greet()
+
+void pop3_greet(void)
 {
   char *s;
   s = unique;
@@ -127,13 +166,13 @@
   s += fmt_ulong(s,(unsigned long) now());
   *s++ = '@';
   *s++ = 0;
-  puts("+OK <");
-  puts(unique);
-  puts(hostname);
-  puts(">\r\n");
+  putstr("+OK <");
+  putstr(unique);
+  putstr(hostname);
+  putstr(">\r\n");
   flush();
 }
-void pop3_user(arg) char *arg;
+void pop3_user(char *arg)
 {
   if (!*arg) { err_syntax(); return; }
   okay();
@@ -141,13 +180,13 @@
   if (!stralloc_copys(&username,arg)) die_nomem(); 
   if (!stralloc_0(&username)) die_nomem(); 
 }
-void pop3_pass(arg) char *arg;
+void pop3_pass(char *arg)
 {
   if (!seenuser) { err_wantuser(); return; }
   if (!*arg) { err_syntax(); return; }
   doanddie(username.s,username.len,arg);
 }
-void pop3_apop(arg) char *arg;
+void pop3_apop(char *arg)
 {
   char *space;
   space = arg + str_chr(arg,' ');
@@ -165,9 +204,7 @@
 , { 0, err_authoriz, 0 }
 } ;
 
-void main(argc,argv)
-int argc;
-char **argv;
+int main(int argc, char **argv)
 {
   sig_alarmcatch(die);
   sig_pipeignore();
@@ -179,5 +216,5 @@
  
   pop3_greet();
   commands(&ssin,pop3commands);
-  die();
+  return 1;
 }
diff -ruN qmail-1.03-orig/qmail-pw2u.c qmail-1.03-ldap-20060201-orig/qmail-pw2u.c
--- qmail-1.03-orig/qmail-pw2u.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-pw2u.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "readwrite.h"
 #include "subfd.h"
@@ -16,6 +17,7 @@
 #include "auto_break.h"
 #include "auto_qmail.h"
 #include "auto_usera.h"
+#include "byte.h"
 
 void die_chdir()
 {
@@ -67,7 +69,7 @@
   _exit(111);
 }
 
-char *dashcolon = "-:";
+const char *dashcolon = "-:";
 int flagalias = 0;
 int flagnoupper = 1;
 int homestrategy = 2;
@@ -93,8 +95,8 @@
 void doaccount()
 {
   struct stat st;
-  int i;
-  char *mailnames;
+  unsigned int i;
+  const char *mailnames;
   char *x;
   unsigned int xlen;
 
@@ -194,21 +196,21 @@
 
 void dosubuser()
 {
-  int i;
+  unsigned int i;
   char *x;
   unsigned int xlen;
-  char *uugh;
+  const char *uughs;
 
   x = line.s; xlen = line.len; i = byte_chr(x,xlen,':'); if (i == xlen) return;
   if (!stralloc_copyb(&sub,x,i)) die_nomem();
   ++i; x += i; xlen -= i; i = byte_chr(x,xlen,':'); if (i == xlen) return;
-  uugh = constmap(&mapuser,x,i);
-  if (!uugh) die_user(x,i);
+  uughs = constmap(&mapuser,x,i);
+  if (!uughs) die_user(x,i);
   ++i; x += i; xlen -= i; i = byte_chr(x,xlen,':'); if (i == xlen) return;
 
   if (substdio_puts(subfdout,"=") == -1) die_write();
   if (substdio_put(subfdout,sub.s,sub.len) == -1) die_write();
-  if (substdio_puts(subfdout,uugh) == -1) die_write();
+  if (substdio_puts(subfdout,uughs) == -1) die_write();
   if (substdio_puts(subfdout,dashcolon) == -1) die_write();
   if (substdio_put(subfdout,x,i) == -1) die_write();
   if (substdio_puts(subfdout,":\n") == -1) die_write();
@@ -217,7 +219,7 @@
     if (substdio_puts(subfdout,"+") == -1) die_write();
     if (substdio_put(subfdout,sub.s,sub.len) == -1) die_write();
     if (substdio_put(subfdout,auto_break,1) == -1) die_write();
-    if (substdio_puts(subfdout,uugh) == -1) die_write();
+    if (substdio_puts(subfdout,uughs) == -1) die_write();
     if (substdio_puts(subfdout,dashcolon) == -1) die_write();
     if (substdio_put(subfdout,x,i) == -1) die_write();
     if (substdio_puts(subfdout,"-:\n") == -1) die_write();
@@ -228,7 +230,7 @@
 substdio ss;
 char ssbuf[SUBSTDIO_INSIZE];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -280,7 +282,7 @@
     if (errno != error_noent) die_control();
   }
   else {
-    substdio_fdbuf(&ss,read,fd,ssbuf,sizeof(ssbuf));
+    substdio_fdbuf(&ss,subread,fd,ssbuf,sizeof(ssbuf));
 
     if (!constmap_init(&mapuser,allusers.s,allusers.len,1)) die_nomem();
 
@@ -298,7 +300,7 @@
     if (errno != error_noent) die_control();
   }
   else {
-    substdio_fdbuf(&ss,read,fd,ssbuf,sizeof(ssbuf));
+    substdio_fdbuf(&ss,subread,fd,ssbuf,sizeof(ssbuf));
     for (;;) {
       if (getln(&ss,&line,&match,'\n') == -1) die_read();
       if (substdio_put(subfdout,line.s,line.len) == -1) die_write();
@@ -308,5 +310,5 @@
 
   if (substdio_puts(subfdout,".\n") == -1) die_write();
   if (substdio_flush(subfdout) == -1) die_write();
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/qmail-qmqpc.c qmail-1.03-ldap-20060201-orig/qmail-qmqpc.c
--- qmail-1.03-orig/qmail-qmqpc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-qmqpc.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,6 +2,7 @@
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "getln.h"
 #include "readwrite.h"
@@ -17,33 +18,105 @@
 #include "auto_qmail.h"
 #include "control.h"
 #include "fmt.h"
+#ifdef QMQP_COMPRESS
+#include <zlib.h>
+#endif
 
+
+#ifndef PORT_QMQP /* this is for testing purposes */
 #define PORT_QMQP 628
+#endif
 
-void die_success() { _exit(0); }
-void die_perm() { _exit(31); }
-void nomem() { _exit(51); }
-void die_read() { if (errno == error_nomem) nomem(); _exit(54); }
-void die_control() { _exit(55); }
-void die_socket() { _exit(56); }
-void die_home() { _exit(61); }
-void die_temp() { _exit(71); }
-void die_conn() { _exit(74); }
-void die_format() { _exit(91); }
+void die_success(void) { _exit(0); }
+void die_perm(void) { _exit(31); }
+void nomem(void) { _exit(51); }
+void die_read(void) { if (errno == error_nomem) nomem(); _exit(54); }
+void die_control(void) { _exit(55); }
+void die_socket(void) { _exit(56); }
+void die_home(void) { _exit(61); }
+void die_temp(void) { _exit(71); }
+void die_conn(void) { _exit(74); }
+void die_format(void) { _exit(91); }
 
+int timeoutconnect = 60;
 int lasterror = 55;
 int qmqpfd;
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+#ifdef QMQP_COMPRESS
+z_stream stream;
+char zbuf[4096];
+
+void compression_init(void)
+{
+  stream.zalloc = Z_NULL;
+  stream.zfree = Z_NULL;
+  stream.opaque = Z_NULL;
+  stream.avail_out = sizeof(zbuf);
+  stream.next_out = zbuf;
+  if (deflateInit(&stream,Z_DEFAULT_COMPRESSION) != Z_OK)
+    die_format();
+}
+void compression_done(void)
+{
+  int r;
+
+  do {
+    r = deflate(&stream,Z_FINISH);
+    switch (r) {
+    case Z_OK:
+      if (stream.avail_out == 0) {
+	r = timeoutwrite(60,qmqpfd,zbuf,sizeof(zbuf));
+	if (r <= 0) die_conn();
+	stream.avail_out = sizeof(zbuf);
+	stream.next_out = zbuf;
+	r = Z_OK;
+      }
+      break;
+    case Z_STREAM_END:
+      break;
+    default:
+      die_format();
+    }
+  } while (r!=Z_STREAM_END);
+  if (stream.avail_out != sizeof(zbuf)) {
+    /* write left data */
+    r = timeoutwrite(60,qmqpfd,zbuf,sizeof(zbuf)-stream.avail_out);
+    if (r <= 0) die_conn();
+  }
+  if (deflateEnd(&stream) != Z_OK) die_format();
+}
+#endif
+
+int saferead(int fd, void *buf, int len)
 {
   int r;
   r = timeoutread(60,qmqpfd,buf,len);
   if (r <= 0) die_conn();
   return r;
 }
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+int safewrite(int fd, void *buf, int len)
 {
   int r;
+#ifdef QMQP_COMPRESS
+  stream.avail_in = len;
+  stream.next_in = buf;
+  do {
+    r = deflate(&stream, 0);
+    switch (r) {
+    case Z_OK:
+      if (stream.avail_out == 0) {
+	r = timeoutwrite(60,qmqpfd,zbuf,sizeof(zbuf));
+	if (r <= 0) die_conn();
+	stream.avail_out = sizeof(zbuf);
+	stream.next_out = zbuf;
+      }
+      break;
+    default:
+      die_format();
+    }
+  } while (stream.avail_in != 0);
+  return len;
+#endif
   r = timeoutwrite(60,qmqpfd,buf,len);
   if (r <= 0) die_conn();
   return r;
@@ -52,7 +125,7 @@
 char buf[1024];
 substdio to = SUBSTDIO_FDBUF(safewrite,-1,buf,sizeof buf);
 substdio from = SUBSTDIO_FDBUF(saferead,-1,buf,sizeof buf);
-substdio envelope = SUBSTDIO_FDBUF(read,1,buf,sizeof buf);
+substdio envelope = SUBSTDIO_FDBUF(subread,1,buf,sizeof buf);
 /* WARNING: can use only one of these at a time! */
 
 stralloc beforemessage = {0};
@@ -68,7 +141,7 @@
 
   if (slurpclose(0,&message,1024) == -1) die_read();
 
-  strnum[fmt_ulong(strnum,(unsigned long) message.len)] = 0;
+  strnum[fmt_uint(strnum,message.len)] = 0;
   if (!stralloc_copys(&beforemessage,strnum)) nomem();
   if (!stralloc_cats(&beforemessage,":")) nomem();
   if (!stralloc_copys(&aftermessage,",")) nomem();
@@ -78,7 +151,7 @@
   if (line.len < 2) die_format();
   if (line.s[0] != 'F') die_format();
 
-  strnum[fmt_ulong(strnum,(unsigned long) line.len - 2)] = 0;
+  strnum[fmt_uint(strnum,line.len - 2)] = 0;
   if (!stralloc_cats(&aftermessage,strnum)) nomem();
   if (!stralloc_cats(&aftermessage,":")) nomem();
   if (!stralloc_catb(&aftermessage,line.s + 1,line.len - 2)) nomem();
@@ -90,7 +163,7 @@
     if (line.len < 2) break;
     if (line.s[0] != 'T') die_format();
 
-    strnum[fmt_ulong(strnum,(unsigned long) line.len - 2)] = 0;
+    strnum[fmt_uint(strnum,line.len - 2)] = 0;
     if (!stralloc_cats(&aftermessage,strnum)) nomem();
     if (!stralloc_cats(&aftermessage,":")) nomem();
     if (!stralloc_catb(&aftermessage,line.s + 1,line.len - 2)) nomem();
@@ -98,6 +171,8 @@
   }
 }
 
+struct ip_address outip;
+
 void doit(server)
 char *server;
 {
@@ -109,14 +184,18 @@
   qmqpfd = socket(AF_INET,SOCK_STREAM,0);
   if (qmqpfd == -1) die_socket();
 
-  if (timeoutconn(qmqpfd,&ip,PORT_QMQP,10) != 0) {
+  if (timeoutconn(qmqpfd,&ip,&outip,PORT_QMQP,timeoutconnect) != 0) {
     lasterror = 73;
     if (errno == error_timeout) lasterror = 72;
     close(qmqpfd);
     return;
   }
 
-  strnum[fmt_ulong(strnum,(unsigned long) (beforemessage.len + message.len + aftermessage.len))] = 0;
+#ifdef QMQP_COMPRESS
+  compression_init();
+#endif
+  strnum[fmt_uint(strnum, 
+         (beforemessage.len + message.len + aftermessage.len))] = 0;
   substdio_puts(&to,strnum);
   substdio_puts(&to,":");
   substdio_put(&to,beforemessage.s,beforemessage.len);
@@ -124,6 +203,9 @@
   substdio_put(&to,aftermessage.s,aftermessage.len);
   substdio_puts(&to,",");
   substdio_flush(&to);
+#ifdef QMQP_COMPRESS
+  compression_done();
+#endif
 
   for (;;) {
     substdio_get(&from,&ch,1);
@@ -134,18 +216,48 @@
 }
 
 stralloc servers = {0};
+stralloc outgoingip = {0};
+
+#include "dns.h"
+#include "ipalloc.h"
+
+ipalloc ia = {0};
 
-main()
+int main(argc,argv)
+int argc;
+char **argv;
 {
-  int i;
-  int j;
+  unsigned int i;
+  unsigned int j;
 
   sig_pipeignore();
 
   if (chdir(auto_qmail) == -1) die_home();
   if (control_init() == -1) die_control();
+  if ( argv[1] ) {
+    char temp[IPFMT];
+    if (!stralloc_copys(&servers,argv[1])) nomem();
+    dns_init(0);
+    switch (dns_ip(&ia,&servers)) {
+      case DNS_HARD: die_perm();
+      case DNS_SOFT: die_temp();
+      case DNS_MEM: nomem();
+    }
+
+    temp[ip_fmt(temp,&ia.ix[0].ip)]=0;
+    if (!stralloc_copys(&servers, temp)) nomem();
+    if (!stralloc_0(&servers)) nomem();
+  } else
   if (control_readfile(&servers,"control/qmqpservers",0) != 1) die_control();
 
+  if (control_readint(&timeoutconnect,"control/timeoutconnect") == -1)
+    die_control();
+
+  if (control_rldef(&outgoingip, "control/qmqpcip", 0, "0.0.0.0") == -1)
+	  die_control();
+  if (!stralloc_0(&outgoingip)) nomem();
+  if (!ip_scan(outgoingip.s,&outip)) die_control();
+
   getmess();
 
   i = 0;
@@ -155,5 +267,5 @@
       i = j + 1;
     }
 
-  _exit(lasterror);
+  return lasterror;
 }
